

'converts null numeric and string variants to string
FUNCTION StrVariant(v AS VARIANT) AS STRING
 DIM p AS WORD PTR: p=VARPTR(v)
 IF @p=0 THEN FUNCTION="":EXIT FUNCTION
 IF @p=8 THEN FUNCTION=VARIANT$(v): EXIT FUNCTION
 FUNCTION=STR$(VARIANT#(v))
END FUNCTION


FUNCTION ConnectObject( ic AS IConnector ) AS DWORD
 LOCAL hr   AS HRESULT
 hr = CoGetClassObject(ic.CLSID, %CLSCTX_INPROC_SERVER, 0, IID_IClassFactory, VARPTR(ic.cf))
 'IF hr THEN MessageBox(0, "Can't get an object", "Class access error", %MB_OK OR %MB_ICONEXCLAMATION)
 IF hr=0 THEN
  CALL DWORD ic.@cf.@lpVtbl.classCreateInstance USING _
  classCreateInstance(VARPTR(ic.cf), 0, ic.IID, VARPTR(ic.obj)) TO hr
  ' IF hr THEN MessageBox(0, "Can't get an object", "CreateInstance error", %MB_OK OR %MB_ICONEXCLAMATION)
  IF hr = 0 THEN
   EXIT FUNCTION  ' success
  END IF
  CALL DWORD ic.@cf.@lpVtbl.classRelease USING classRelease(ic.cf)
 END IF
 FUNCTION=hr
END FUNCTION


FUNCTION ConnectCallbacks  ( ic AS IConnector ) AS HRESULT
 LOCAL hr    AS HRESULT
 CALL DWORD ic.@Obj.@lpVtbl.QueryInterface USING _
 QueryInterface(ic.obj, IID_IConnectionPointContainer, VARPTR(ic.container)) TO hr
 IF hr THEN
  MessageBox(0, "Can't get IConnectionPointContainer object", "QueryInterface error", %MB_OK OR %MB_ICONEXCLAMATION)
 ELSE
  CALL DWORD ic.@container.@lpVtbl.FindConnectionPoint USING _
  FindConnectionPoint(ic.container, ic.DIID, VARPTR(ic.point)) TO hr
  CALL DWORD ic.@container.@lpVtbl.Release_Connect USING Release_Connect(ic.container)
  IF hr THEN
   MessageBox(0, "Can't get IConnectionPoint object", "FindConnectionPoint error", %MB_OK OR %MB_ICONEXCLAMATION)
  ELSE
   CALL DWORD ic.@point.@lpVtbl.Advise USING Advise(ic.point, ic.events, VARPTR(ic.cookie)) TO hr
   IF hr THEN
    MessageBox(0, "Can't set our IFEEDBACK object", "Advise error", %MB_OK OR %MB_ICONEXCLAMATION)
   END IF
  END IF
 END IF
 FUNCTION=hr
END FUNCTION

FUNCTION DisconnectCallbacks( ic AS IConnector ) AS HRESULT
 DIM hr AS LONG
 CALL DWORD ic.@point.@lpVtbl.Unadvise USING Unadvise(ic.point, ic.cookie) TO hr
 IF hr THEN
  MessageBox(0, "Can't unset our IFEEDBACK object", "Unadvise error", %MB_OK OR %MB_ICONEXCLAMATION)
 END IF
 CALL DWORD ic.@point.@lpVtbl.Release_Point USING Release_Point(ic.point)
 FUNCTION=hr
END FUNCTION

FUNCTION DisconnectObject( ic AS IConnector ) AS HRESULT
 CALL DWORD ic.@obj.@lpVtbl.Release USING Release(ic.obj)
 CALL DWORD ic.@cf.@lpVtbl.classRelease USING classRelease(ic.cf)
END FUNCTION

FUNCTION II_EnableLibraryCallBacks( ic AS IConnector, BYVAL Libr AS DWORD ) AS HRESULT
 CALL DWORD ic.@obj.@lpVTbl.EnableLibraryCallbacks USING EnableLibraryCallbacks (ic.obj,Libr)
END FUNCTION

FUNCTION II_DisableLibraryCallBacks( ic AS IConnector, BYVAL Libr AS DWORD ) AS HRESULT
 CALL DWORD ic.@obj.@lpVTbl.DisableLibraryCallbacks USING DisableLibraryCallbacks (ic.obj,Libr)
END FUNCTION

'DLL library access

FUNCTION II_LoadLibrary(ic AS IConnector, s AS STRING, result AS DWORD) AS DWORD
 s=UCODE$(s)+MKWRD$(0)
 CALL DWORD ic.@obj.@lpVtbl.LoadLibrary_I USING LoadLibrary_I(ic.obj,STRPTR(s),VARPTR(result))
END FUNCTION

FUNCTION II_GetProcAddress(ic AS IConnector, v AS DWORD, s AS STRING,result AS DWORD) AS DWORD
IF v=0 THEN EXIT FUNCTION
 s=UCODE$(s)+MKWRD$(0)
 CALL DWORD ic.@obj.@lpVtbl.GetProcAddress_I USING GetProcAddress_I(ic.obj,v,STRPTR(s),VARPTR(result))
END FUNCTION

FUNCTION II_FreeLibrary(ic AS IConnector, v AS DWORD, result AS DWORD) AS DWORD
 IF v=0 THEN EXIT FUNCTION
 CALL DWORD ic.@obj.@lpVtbl.FreeLibrary_I USING FreeLibrary_I(ic.obj,v,VARPTR(result))
END FUNCTION
