'---------------------------------------------------------------------------------------
' Object IUnknown Interface Functions
'---------------------------------------------------------------------------------------

FUNCTION AddRef ALIAS "AddRef" ( _
 BYVAL this AS IObject PTR _
 ) AS DWORD
    INCR @this.count: FUNCTION = @this.count
END FUNCTION

FUNCTION QueryInterface( _
    BYVAL this AS IOBJECT PTR, _
    BYREF vTableGuid AS GUID, _
    BYVAL ppv AS DWORD PTR _
    ) AS HRESULT
    IF (vTableGuid = IID_IConnectionPointContainer) THEN
        'MSGBOX "QueryInterface IConnectionPointContainer"
        @ppv = this + 8 ' offsetof(MyRealIExampleEvts2, container)
    ELSEIF (vTableGuid = IID_IUnknown) OR (vTableGuid= IID_MyObject) OR (vTableGuid = IID_IDispatch) THEN
        @ppv = this
    ELSE
        @ppv = 0
        FUNCTION = %E_NOINTERFACE: EXIT FUNCTION
    END IF
    CALL DWORD @this.@lpVTbl.AddRef USING AddRef(this)
    FUNCTION = %NOERROR
END FUNCTION

FUNCTION Release ALIAS "Release" ( _
 BYVAL this AS IObject PTR _
 ) AS DWORD
    DECR @this.count
    IF @this.count=0 THEN
        IF @this.tex THEN SysFreeString(@this.tex) 'win32api
        GlobalFree(this) 'win32api
        InterlockedDecrement(OutstandingObjects) 'win32api
        FUNCTION=0: EXIT FUNCTION
    END IF
    FUNCTION = @this.count
END FUNCTION

'---------------------------------------------------------------------------------------
' Object Dispatch Interface Functions
'---------------------------------------------------------------------------------------

' helper function called by getTypeInfo
FUNCTION loadMyTypeInfo() AS HRESULT
    DIM hr          AS HRESULT
    DIM pTypeLib    AS ITypeLib PTR ' was LPTYPELIB

    hr = LoadRegTypeLib(CLSID_TypeLib, 1, 0, 0, VARPTR(pTypeLib)) 'Language neutral
    IF hr = 0 THEN
        CALL DWORD @pTypeLib.@lpVTbl.GetTypeInfoOfGuid _
        USING GetTypeInfoOfGuid(pTypeLib, IID_MyObject, VARPTR(MyTypeInfo)) TO hr
        'USING GetTypeInfoOfGuid(pTypeLib, CLSID_MyObject, VARPTR(MyTypeInfo)) TO hr
        IF hr = 0 THEN
            CALL DWORD @pTypeLib.@lpVTbl.Release USING Release(pTypeLib)
            CALL DWORD @MyTypeInfo.@lpVTbl.AddRef USING AddRef(MyTypeInfo)
        END IF
    END IF
    FUNCTION = hr
END FUNCTION

FUNCTION GetTypeInfoCount( _
 BYVAL this AS ITypeLib PTR, _
 BYVAL pCount AS DWORD PTR  _
 ) AS DWORD
    @pCount = 1: FUNCTION=%S_OK
END FUNCTION

FUNCTION GetTypeInfo ( _
 BYVAL this AS ITypeInfo PTR, _
 BYVAL itinfo AS DWORD, _
 BYVAL lc AS LCID, _
 BYVAL pTypeInfo AS DWORD PTR _
 ) AS DWORD
    DIM hr AS HRESULT
    @pTypeInfo = 0 'assume an error
    IF itinfo THEN
        hr = %DISP_E_BADINDEX 'hr = ResultFromScode(%DISP_E_BADINDEX) ' same on 32bit systems
    ELSEIF MyTypeInfo THEN
        CALL DWORD @MyTypeInfo.@lpVTbl.AddRef USING AddRef(MyTypeInfo): hr = 0
    ELSE
        hr = loadMyTypeInfo()
    END IF
    IF hr = 0 THEN @pTypeInfo = MyTypeInfo
    FUNCTION = hr
END FUNCTION

FUNCTION GetIDsOfNames( _
 BYVAL this AS IObject PTR, _
 BYREF riid AS REFIID, _
 BYVAL rgszNames AS DWORD PTR, _
 BYVAL cNames AS DWORD, _
 BYVAL lc AS LCID, _
 BYVAL rgdispid AS DISPID PTR _
 ) AS HRESULT
  DIM hr AS HRESULT
  IF MyTypeInfo=0 THEN hr = loadMyTypeInfo(): IF hr THEN FUNCTION = hr: EXIT FUNCTION
  hr= DispGetIDsOfNames(MyTypeInfo, rgszNames, cNames, rgdispid)
  FUNCTION = hr
END FUNCTION


FUNCTION Invoke( _
 BYVAL this AS IObject PTR, _
 BYVAL ndispid AS DISPID, _           ' id of function to be invoked
 BYREF riid AS REFIID, _              ' normally null guid
 BYVAL lc AS LCID, _                  ' locale: neutral=0
 BYVAL wFlags AS WORD, _              ' %DISPATCH_METHOD = 1  %DISPATCH_PROPERTYGET = 2 %DISPATCH_PROPERTYPUT = 4 %DISPATCH_PROPERTYPUTREF = 8
 BYVAL params AS DISPPARAMS PTR, _    ' pointer to dispparams structure
 BYVAL result AS VARIANT PTR, _       ' pointer to result
 BYVAL pexcepinfo AS EXCEPINFO PTR, _ ' pointer to error info
 BYVAL puArgErr AS DWORD PTR _        '
 ) AS HRESULT
  DIM hr AS HRESULT
  IF  riid<>IID_NULL THEN FUNCTION = %DISP_E_UNKNOWNINTERFACE: EXIT FUNCTION
  IF MyTypeInfo=0    THEN hr = loadMyTypeInfo():IF hr THEN FUNCTION=hr: EXIT FUNCTION
  IF ndispid<10000 THEN
   hr = DispInvoke( this, MyTypeInfo, ndispid, wFlags, params, result, pexcepinfo, puArgErr)
   FUNCTION=hr: EXIT FUNCTION
  END IF
  DIM hn AS DWORD       : hn=0
  DIM g  AS VARIANT PTR : g=@params.VariantArgs
  DIM e  AS DWORD       : e=@params.countArgs
  IF e=0             THEN @result=0: EXIT FUNCTION
  IF ndispid=10001  THEN
   hn=VARIANT#(@g[e-1]): IF hn=0 THEN EXIT FUNCTION 
   IF hn<1000000      THEN EXIT FUNCTION 'a simple precaution but need stronger checking
   CALL DWORD hn USING InvokeHostLibraryProc( @params.countArgs, @params.VariantArgs, result )
  END IF
  '#INCLUDE "inc\COMserver\diagnostic.inc"
END FUNCTION
