

FUNCTION QueryInterface_Connect( _
    BYVAL this AS IConnectionPointContainer PTR, _
    BYREF vTableGuid AS GUID, _
    BYVAL ppv AS DWORD PTR _
    ) AS HRESULT
    'MSGBOX "QueryInterface_Connect"
    FUNCTION = QueryInterface(this - 8, vTableGuid, ppv) ' container
END FUNCTION

FUNCTION AddRef_Connect( _
    BYVAL this AS IConnectionPointContainer PTR _
    ) AS DWORD
    FUNCTION = AddRef(this - 8) ' container
    'MSGBOX "AddRef_Connect done"
END FUNCTION

FUNCTION Release_Connect( _
    BYVAL this AS IConnectionPointContainer PTR _
    ) AS DWORD
    'MSGBOX "Release_Connect"
    FUNCTION = Release(this - 8) ' container
END FUNCTION

FUNCTION EnumConnectionPoints(_
    BYVAL this AS IConnectionPointContainer PTR, _
    BYVAL enumPoints AS DWORD PTR _
    ) AS HRESULT
    'MSGBOX "EnumConnectionPoints"
    @enumPoints = 0 ' because only 1 connection point
    FUNCTION = %E_NOTIMPL ' is this allowed?
END FUNCTION

FUNCTION FindConnectionPoint( _
    BYVAL this AS DWORD PTR, _
    BYREF vTableGuid AS GUID, _
    BYVAL ppv AS DWORD PTR _
    ) AS LONG
    'MSGBOX "FindConnectionPoint  this"+HEX$(this)+" ppv "+HEX$(ppv)
    'MSGBOX GUIDTXT$(vTableGuid)+$CRLF+GUIDTXT$(DIID_IFeedback)+$CRLF
    IF vTableGuid = DIID_IFeedback THEN
        DIM MyObj AS IObject PTR
        MyObj = this - 8 ' offsetof container
        @ppv = VARPTR(@MyObj.point)
        AddRef_Connect(this)
        'MSGBOX "FindConnectionPoint done"
        FUNCTION = %S_OK: EXIT FUNCTION
    END IF
    'MSGBOX "Not supported"
    ' We don't support any other app objects connecting to IExampleEvts2
    @ppv = 0
    FUNCTION = %E_NOINTERFACE
END FUNCTION

' Our IConnectionPoint sub-object  -----------------

FUNCTION QueryInterface_Point( _
    BYVAL this AS IConnectionPoint PTR, _
    BYREF vTableGuid AS GUID, _
    BYVAL ppv AS DWORD PTR _
    ) AS HRESULT
    'MSGBOX "QueryInterface_Point"
    FUNCTION = QueryInterface(this - 12, vTableGuid, ppv) ' delegate
END FUNCTION

FUNCTION AddRef_Point( _
    BYVAL this AS IConnectionPoint PTR _
    ) AS HRESULT
    'MSGBOX "AddRef_Point"
    FUNCTION = AddRef(this - 12) ' delegate
END FUNCTION

FUNCTION Release_Point( _
    BYVAL this AS IConnectionPoint PTR _
    ) AS HRESULT
    'MSGBOX "Release_Point"
    FUNCTION = Release(this - 12) ' delegate
END FUNCTION

FUNCTION GetConnectionInterface( _
    BYVAL this AS IConnectionPoint PTR, _
    BYREF vTableGuid AS GUID _
    ) AS HRESULT
    'MSGBOX "GetConnectionInterface"
    ' CopyMemory(vTableGuid, DIID_IFeedback, SIZEOF(GUID))
    vTableGuid = DIID_IFeedback
    FUNCTION = %S_OK
END FUNCTION

FUNCTION GetConnectionPointContainer( _
    BYVAL this AS IConnectionPoint PTR, _
    BYVAL ppv AS DWORD PTR _
    ) AS HRESULT
    'MSGBOX "GetConnectionPointContainer"
    DIM MyObj AS IObject PTR
    MyObj = this - 12 ' offsetof(point)
    @ppv = VARPTR(@MyObj.container)
    AddRef_Point(this) 'delegate
    FUNCTION = %S_OK
END FUNCTION

'convolutions!
FUNCTION Advise( _
    BYVAL this AS IConnectionPoint PTR, _  ' sub objectof Iobject
    BYVAL obj AS IFeedback PTR, _          ' IUNKNOWN PTR
    BYVAL cookie AS DWORD PTR _            ' pointer to pointer to IFeedback
    ) AS HRESULT
    'MSGBOX "Advise"
    REGISTER hr AS HRESULT
    DIM MyObj AS IObject PTR
    MyObj = this - 12 ' offsetof(point)
    ' only 1 ifeedback
    IF @MyObj.feedback THEN FUNCTION = %CONNECT_E_ADVISELIMIT: EXIT FUNCTION
    CALL DWORD @obj.@lpVTbl.QueryInterface USING _
    QueryInterface(obj, DIID_IFeedback, VARPTR(@MyObj.feedback)) TO hr
    ' for use in UnAdvise
    @cookie = @MyObj.feedback
    CallClients = @cookie ' store the IFeedback address
    'MSGBOX "CallClient pt "+HEX$(CallClients)
    FUNCTION = hr
END FUNCTION

FUNCTION Unadvise( _
    BYVAL this AS IConnectionPoint PTR, _
    BYVAL cookie AS IFeedback PTR _   ' as pointer to feedback
    ) AS HRESULT
    'MSGBOX "Unadvise"
    DIM MyObj AS IObject PTR
    MyObj = this - 12 ' offsetof(point)
    IF (cookie<>0) AND (cookie = @MyObj.feedback) THEN
        CALL DWORD @cookie.@lpVTbl.Release USING Release(cookie)
        @MyObj.feedback = 0
        CallClients=0
        FUNCTION = %S_OK: EXIT FUNCTION
    END IF
    FUNCTION = %CONNECT_E_NOCONNECTION
END FUNCTION

FUNCTION EnumConnections( _
    BYVAL this AS IConnectionPoint PTR, _
    BYVAL enumConnects AS DWORD PTR _
    ) AS HRESULT
    'MSGBOX "EnumConnections"
    @enumConnects = 0
    FUNCTION = %E_NOTIMPL
END FUNCTION
