

FUNCTION QueryInterface_Connect(BYVAL this AS IConnectionPointContainer PTR, _
    BYREF vTableGuid AS GUID, _
    BYVAL ppv AS DWORD PTR _
    ) AS HRESULT
    FUNCTION = QueryInterface(this - 8, vTableGuid, ppv) ' container
END FUNCTION
static STDMETHODIMP QueryInterface_Connect(IConnectionPointContainer *this, REFIID vTableGuid, void **ppv)
{ return(QueryInterface((IExampleEvts2 *)((char *)this - offsetof(MyRealIExampleEvts2, container)), vTableGuid, ppv)); }


FUNCTION AddRef_Connect( _
    BYVAL this AS IConnectionPointContainer PTR _
    ) AS DWORD
    FUNCTION = AddRef(this - 8) ' container
END FUNCTION
static STDMETHODIMP_(ULONG) AddRef_Connect(IConnectionPointContainer *this)
{ return(AddRef((IExampleEvts2 *)((char *)this - offsetof(MyRealIExampleEvts2, container)))); }


FUNCTION Release_Connect( _
    BYVAL this AS IConnectionPointContainer PTR _
    ) AS DWORD
    FUNCTION = Release(this - 8) ' container
END FUNCTION
static STDMETHODIMP_(ULONG) Release_Connect(IConnectionPointContainer *this)
{ return(Release((IExampleEvts2 *)((char *)this - offsetof(MyRealIExampleEvts2, container)))); }


FUNCTION EnumConnectionPoints(_
    BYVAL this AS IConnectionPointContainer PTR, _
    BYVAL enumPoints AS DWORD PTR _
    ) AS HRESULT
    @enumPoints = 0 ' because only 1 connection point
    FUNCTION = %E_NOTIMPL
END FUNCTION
static STDMETHODIMP EnumConnectionPoints(IConnectionPointContainer *this, IEnumConnectionPoints **enumPoints)
{ *enumPoints = 0;
 return(E_NOTIMPL); }
 

FUNCTION FindConnectionPoint( _
    BYVAL this AS DWORD PTR, _
    BYVAL vTableGuid AS GUID, _
    BYVAL ppv AS DWORD PTR _
    ) AS LONG
    IF vTableGuid = DIID_IFeedbackVTbl THEN
        DIM MyObject AS IObject PTR
        MyObject = this - 8 ' offsetof container
        @ppv = VARPTR(@MyObject.point)
        AddRef_Connect(this)
        FUNCTION = %S_OK: EXIT FUNCTION
    END IF
    ' We don't support any other app objects connecting to IExampleEvts2
    @ppv = 0
    FUNCTION = %E_NOINTERFACE
END FUNCTION
static STDMETHODIMP FindConnectionPoint(IConnectionPointContainer *this, REFIID vTableGuid, IConnectionPoint **ppv) 
{
	if (IsEqualIID(vTableGuid, &DIID_IFeedback2))
	{
		register MyRealIExampleEvts2		*iExample;
		iExample = (MyRealIExampleEvts2 *)((char *)this - offsetof(MyRealIExampleEvts2, container));
		*ppv = &iExample->point;
		AddRef_Connect(this);
		return(S_OK);
	}
	*ppv = 0;
	return(E_NOINTERFACE);
}


' Our IConnectionPoint sub-object  -----------------

FUNCTION QueryInterface_Point( _
    BYVAL this AS IConnectionPoint PTR, _
    BYREF vTableGuid AS GUID, _
    BYVAL ppv AS DWORD PTR _
    ) AS HRESULT
    FUNCTION = QueryInterface(this - 12, vTableGuid, ppv) ' delegate
END FUNCTION
static STDMETHODIMP QueryInterface_Point(IConnectionPoint *this, REFIID vTableGuid, void **ppv)
{
	return(QueryInterface((IExampleEvts2 *)((char *)this - offsetof(MyRealIExampleEvts2, point)), vTableGuid, ppv));
}


FUNCTION AddRef_Point( _
    BYVAL this AS IConnectionPoint PTR _
    ) AS HRESULT
    FUNCTION = AddRef(this - 12) ' delegate
END FUNCTION
static STDMETHODIMP_(ULONG) AddRef_Point(IConnectionPoint *this)
{
	return(AddRef((IExampleEvts2 *)((char *)this - offsetof(MyRealIExampleEvts2, point))));
}


FUNCTION Release_Point( _
    BYVAL this AS IConnectionPoint PTR _
    ) AS HRESULT
    FUNCTION = Release(this - 12) ' delegate
END FUNCTION
static STDMETHODIMP_(ULONG) Release_Point(IConnectionPoint *this)
{
	return(Release((IExampleEvts2 *)((char *)this - offsetof(MyRealIExampleEvts2, point))));
}


FUNCTION GetConnectionInterface( _
    BYVAL this AS IConnectionPoint PTR, _
    BYREF vTableGuid AS GUID _
    ) AS HRESULT
    ' CopyMemory(vTableGuid, DIID_IFeedbackVTbl, SIZEOF(GUID))
    vTableGuid = DIID_IFeedbackVTbl
    FUNCTION = %S_OK
END FUNCTION
static STDMETHODIMP GetConnectionInterface(IConnectionPoint *this, IID *vTableGuid) 
{
	CopyMemory(vTableGuid, &DIID_IFeedback2, sizeof(GUID));
	return(S_OK);
}


FUNCTION GetConnectionPointContainer( _
    BYVAL this AS IConnectionPoint PTR, _
    BYVAL ppv AS DWORD PTR _
    ) AS HRESULT
    DIM MyObject AS IObject PTR
    MyObject = this - 12 ' offsetof(point)
    @ppv = VARPTR(@MyObject.container)
    AddRef_Point(this) 'delegate
    FUNCTION = %S_OK
END FUNCTION
static STDMETHODIMP GetConnectionPointContainer(IConnectionPoint *this, IConnectionPointContainer **ppv) 
{
	register MyRealIExampleEvts2	*iExample;
	iExample = (MyRealIExampleEvts2 *)((char *)this - offsetof(MyRealIExampleEvts2, point));
	*ppv = &iExample->container;
	AddRef_Point(this);
	return(S_OK);
}


'convolutions!
FUNCTION Advise( _
    BYVAL this AS IConnectionPoint PTR, _  ' sub objectof Iobject
    BYVAL obj AS IFeedback PTR, _          ' IUNKNOWN PTR
    BYVAL cookie AS DWORD PTR _            ' pointer to IFeedback
    ) AS HRESULT
    REGISTER hr AS HRESULT
    DIM MyObj AS IObject PTR
    MyObj = this - 12 ' offsetof(point)
    ' only 1 ifeedback
    IF @MyObj.feedback THEN FUNCTION = %CONNECT_E_ADVISELIMIT: EXIT FUNCTION
    CALL DWORD @obj.@lpVTbl.QueryInterface USING _
    QueryInterface(obj, DIID_IFeedbackVTbl, VARPTR(@MyObj.feedback)) TO hr
    ' for use in UnAdvise
    @cookie = @MyObj.feedback
    FUNCTION = hr
END FUNCTION
static STDMETHODIMP Advise(IConnectionPoint *this, IUnknown *obj, DWORD *cookie) 
{
	register HRESULT			hr;
	register MyRealIExampleEvts2	*iExample;
	iExample = (MyRealIExampleEvts2 *)((char *)this - offsetof(MyRealIExampleEvts2, point));
	if (iExample->feedback) return(CONNECT_E_ADVISELIMIT); 
	hr = obj->lpVtbl->QueryInterface(obj, &DIID_IFeedback2, (void **)&iExample->feedback);
	*cookie = (DWORD)iExample->feedback;
	return(hr);
}


FUNCTION Unadvise( _
    BYVAL this AS IConnectionPoint PTR, _
    BYVAL cookie AS IObject PTR _   ' cookie point to ?
    ) AS HRESULT
    DIM MyObject AS IObject PTR
    MyObject = this - 12 ' offsetof(point)
    IF (cookie<>0) AND (cookie = @MyObject.feedback) THEN
        CALL DWORD @cookie.@lpVTbl.Release USING Release(cookie)
        @MyObject.feedback = 0
        FUNCTION = %S_OK: EXIT FUNCTION
    END IF
    FUNCTION = %CONNECT_E_NOCONNECTION
END FUNCTION
static STDMETHODIMP Unadvise(IConnectionPoint *this, DWORD cookie) 
{
	register MyRealIExampleEvts2	*iExample;
	iExample = (MyRealIExampleEvts2 *)((char *)this - offsetof(MyRealIExampleEvts2, point));
	if (cookie && (IFeedback2 *)cookie == iExample->feedback)
	{
		((IFeedback2 *)cookie)->lpVtbl->Release((IFeedback2 *)cookie);
		iExample->feedback = 0;
		return(S_OK);
	}
	return(CONNECT_E_NOCONNECTION);
}


FUNCTION EnumConnections( _
    BYVAL this AS IConnectionPoint PTR, _
    BYVAL enumConnects AS DWORD PTR _
    ) AS HRESULT
    @enumConnects = 0
    FUNCTION = %E_NOTIMPL
END FUNCTION
static STDMETHODIMP EnumConnections(IConnectionPoint *this, IEnumConnections **enumConnects)
{
	*enumConnects = 0; 
	return(E_NOTIMPL);
}

